searchNodes=[{"type":"module","title":"Untangle","doc":"Logging/inspecting data, and timing functions, with code location information. Logging/inspecting Untangle provides alternatives for IO.inspect and the macros in Elixir's Logger to output code location information. It also provides a polyfill for dbg which was introduce in Elixir 1.14 The first argument is inspect ed and the second argument (if provided) is used as a label: &gt; import Untangle Untangle &gt; debug ( :no , &quot;the answer is&quot; ) # log at debug 11 : 19 : 09.915 [ debug ] [ iex : 2 ] the answer is : :no :no &gt; dump ( %{ a : :map } , &quot;it&quot; ) # inspect something on stdout [ iex : 3 ] it : %{ a : :map } %{ a : :map } When used in a code file, the location information becomes more useful, e.g.: [ lib / test_untangle . ex : 15 @ Test.Untangle . example / 2 ] Here &#39; s an empty list : [ ] You may also notice from the iex output that it returns its first argument. This makes it ideal for inserting into a pipeline for debugging purposes: do_something ( ) |&gt; debug ( &quot;output of do_something/0&quot; ) When you are done debugging something, the location of the debug statement is already in the output so you know where to remove it, comment it out, or simply change warn or info for debug if you only need it during development :-) Timing functions You can decorate functions to measure and log their execution time: use Untangle @decorate time ( ) def fun ( ) , do : :stuff will output something like [info] Time to run MyModule.fun/0: 1 ms Installation If available in Hex , the package can be installed by adding untangle to your list of dependencies in mix.exs : def deps do [ { :untangle , &quot;~&gt; 0.3&quot; } ] end Configure as default dbg/2 handler In config/config.exs config :elixir, :dbg_callback, {Untangle, :custom_dbg, []} Docs The docs can be found at https://hexdocs.pm/untangle . Copyright and License Copyright (c) 2022 Bonfire contributors Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"Untangle.html"},{"type":"function","title":"Untangle.custom_dbg/3","doc":"Custom backend for Kernel.dbg/2 . This function provides a backend for Kernel.dbg/2 . This function: may log or print information about the given env may log or print information about code and its returned value (using opts to inspect terms) returns the value returned by evaluating code","ref":"Untangle.html#custom_dbg/3"},{"type":"macro","title":"Untangle.debug/3","doc":"Like dump , but for logging at debug level","ref":"Untangle.html#debug/3"},{"type":"macro","title":"Untangle.dump/3","doc":"IO.inspect but outputs to Logger with position information, an optional label and configured not to truncate output too much.","ref":"Untangle.html#dump/3"},{"type":"macro","title":"Untangle.error/3","doc":"Similar to dump , but for logging at error level, and returns an error tuple: an error tuple with the label, if any an error tuple with the passed value otherwise iex&gt; error ( :value ) ### [error] :value { :error , :value } iex&gt; error ( { :error , :value } ) ### [error] :value { :error , :value } iex&gt; error ( :value , &quot;with label&quot; ) ### [error] with label: :value { :error , &quot;with label&quot; } iex&gt; error ( { :error , :value } , &quot;with label&quot; ) ### [error] with label: :value { :error , &quot;with label&quot; }","ref":"Untangle.html#error/3"},{"type":"function","title":"Untangle.format_application_location/3","doc":"","ref":"Untangle.html#format_application_location/3"},{"type":"function","title":"Untangle.format_location/2","doc":"","ref":"Untangle.html#format_location/2"},{"type":"function","title":"Untangle.format_stacktrace/1","doc":"Formats the stacktrace. A stacktrace must be given as an argument. If not, the stacktrace is retrieved from Process.info/2 .","ref":"Untangle.html#format_stacktrace/1"},{"type":"function","title":"Untangle.format_stacktrace_entry/1","doc":"Receives a stacktrace entry and formats it into a string.","ref":"Untangle.html#format_stacktrace_entry/1"},{"type":"function","title":"Untangle.format_stacktrace_label/2","doc":"","ref":"Untangle.html#format_stacktrace_label/2"},{"type":"function","title":"Untangle.format_stacktrace_sliced/3","doc":"","ref":"Untangle.html#format_stacktrace_sliced/3"},{"type":"macro","title":"Untangle.info/3","doc":"Like dump , but for logging at info level","ref":"Untangle.html#info/3"},{"type":"function","title":"Untangle.log_level?/1","doc":"","ref":"Untangle.html#log_level?/1"},{"type":"macro","title":"Untangle.maybe_dbg/3","doc":"Like debug , but will do nothing unless the :debug option is truthy","ref":"Untangle.html#maybe_dbg/3"},{"type":"macro","title":"Untangle.maybe_info/3","doc":"Like maybe_dbg , but requires the :verbose option to be set. Intended for large outputs.","ref":"Untangle.html#maybe_info/3"},{"type":"function","title":"Untangle.module_name/1","doc":"","ref":"Untangle.html#module_name/1"},{"type":"macro","title":"Untangle.smart/3","doc":"Tries to 'do what i mean'. Requires the debug option to be set regardless. If verbose is also set, will inspect else will attempt to print some (hopefully smaller) type-dependent summary of the data (list length, map keys).","ref":"Untangle.html#smart/3"},{"type":"macro","title":"Untangle.warn/3","doc":"Like dump , but for logging at warn level","ref":"Untangle.html#warn/3"},{"type":"module","title":"Untangle.Time","doc":"","ref":"Untangle.Time.html"},{"type":"macro","title":"Untangle.Time.time/0","doc":"","ref":"Untangle.Time.html#time/0"},{"type":"function","title":"Untangle.Time.time/2","doc":"","ref":"Untangle.Time.html#time/2"},{"type":"extras","title":"Untangle","doc":"Logging/inspecting data, and timing functions, with code location information.","ref":"readme.html"},{"type":"extras","title":"Untangle - Logging/inspecting","doc":"Untangle provides alternatives for IO.inspect and the macros in Elixir's Logger to output code location information. It also provides a polyfill for dbg which was introduce in Elixir 1.14 The first argument is inspect ed and the second argument (if provided) is used as a label: &gt; import Untangle Untangle &gt; debug ( :no , &quot;the answer is&quot; ) # log at debug 11 : 19 : 09.915 [ debug ] [ iex : 2 ] the answer is : :no :no &gt; dump ( %{ a : :map } , &quot;it&quot; ) # inspect something on stdout [ iex : 3 ] it : %{ a : :map } %{ a : :map } When used in a code file, the location information becomes more useful, e.g.: [ lib / test_untangle . ex : 15 @ Test.Untangle . example / 2 ] Here &#39; s an empty list : [ ] You may also notice from the iex output that it returns its first argument. This makes it ideal for inserting into a pipeline for debugging purposes: do_something ( ) |&gt; debug ( &quot;output of do_something/0&quot; ) When you are done debugging something, the location of the debug statement is already in the output so you know where to remove it, comment it out, or simply change warn or info for debug if you only need it during development :-)","ref":"readme.html#logging-inspecting"},{"type":"extras","title":"Untangle - Timing functions","doc":"You can decorate functions to measure and log their execution time: use Untangle @decorate time ( ) def fun ( ) , do : :stuff will output something like [info] Time to run MyModule.fun/0: 1 ms","ref":"readme.html#timing-functions"},{"type":"extras","title":"Untangle - Installation","doc":"If available in Hex , the package can be installed by adding untangle to your list of dependencies in mix.exs : def deps do [ { :untangle , &quot;~&gt; 0.3&quot; } ] end Configure as default dbg/2 handler","ref":"readme.html#installation"},{"type":"extras","title":"Untangle - In config/config.exs","doc":"config :elixir, :dbg_callback, {Untangle, :custom_dbg, []} Docs The docs can be found at https://hexdocs.pm/untangle .","ref":"readme.html#in-config-config-exs"},{"type":"extras","title":"Untangle - Copyright and License","doc":"Copyright (c) 2022 Bonfire contributors Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license"}]